## apache-arrow 23.0.0

=== python/CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
# Includes code assembled from BSD/MIT/Apache-licensed code from some 3rd-party
# projects, including Kudu, Impala, and libdynd. See python/LICENSE.txt

cmake_minimum_required(VERSION 3.25)
project(pyarrow)

# This is needed for 3.13 free-threading. CMake used to add Python
# include directories with `-isystem`, which led to some Python-internal
# includes to resolve to normal 3.13 includes (cause -isystem includes
# are searched after system directories), instead of 3.13-freethreading,
# which in turn meant that Py_GIL_DISABLED was not set.
set(CMAKE_NO_SYSTEM_FROM_IMPORTED ON)

set(PYARROW_VERSION "23.0.0")
string(REGEX MATCH "^[0-9]+\\.[0-9]+\\.[0-9]+" PYARROW_BASE_VERSION "${PYARROW_VERSION}")

# Generate SO version and full SO version
project(pyarrow VERSION "${PYARROW_BASE_VERSION}")
set(PYARROW_VERSION_MAJOR "${pyarrow_VERSION_MAJOR}")
set(PYARROW_VERSION_MINOR "${pyarrow_VERSION_MINOR}")
set(PYARROW_VERSION_PATCH "${pyarrow_VERSION_PATCH}")
# pyarrow 1.x.y => SO version is "10x", full SO version is "10x.y.0"
# Example: for 18.0.0 --> PYARROW_SO_VERSION=1800, PYARROW_FULL_SO_VERSION=1800.0.0
math(EXPR PYARROW_SO_VERSION "${PYARROW_VERSION_MAJOR} * 100 + ${PYARROW_VERSION_MINOR}")
set(PYARROW_FULL_SO_VERSION "${PYARROW_SO_VERSION}.${PYARROW_VERSION_PATCH}.0")

# Running from a Python sdist tarball
set(LOCAL_CMAKE_MODULES "${CMAKE_SOURCE_DIR}/cmake_modules")
if(EXISTS "${LOCAL_CMAKE_MODULES}")
  set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${LOCAL_CMAKE_MODULES})
endif()

# Running from a git source tree
set(CPP_CMAKE_MODULES "${CMAKE_SOURCE_DIR}/../cpp/cmake_modules")
if(EXISTS "${CPP_CMAKE_MODULES}")
  set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CPP_CMAKE_MODULES})
endif()

if(PYARROW_CPP_HOME)
  list(INSERT CMAKE_PREFIX_PATH 0 "${PYARROW_CPP_HOME}")
endif()

include(CMakeParseArguments)

# MACOSX_RPATH is enabled by default.
# https://www.cmake.org/cmake/help/latest/policy/CMP0042.html
cmake_policy(SET CMP0042 NEW)

# Only interpret if() arguments as variables or keywords when unquoted.
# https://www.cmake.org/cmake/help/latest/policy/CMP0054.html
cmake_policy(SET CMP0054 NEW)

# RPATH settings on macOS do not affect install_name.
# https://cmake.org/cmake/help/latest/policy/CMP0068.html
if(POLICY CMP0068)
  cmake_policy(SET CMP0068 NEW)
endif()

# find_package() uses <PackageName>_ROOT variables.
# https://cmake.org/cmake/help/latest/policy/CMP0074.html
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()

# RPATH entries are properly escaped in the intermediary CMake install script.
# https://cmake.org/cmake/help/latest/policy/CMP0095.html
if(POLICY CMP0095)
  cmake_policy(SET CMP0095 NEW)
endif()

# Use the first Python installation on PATH, not the newest one
set(Python3_FIND_STRATEGY "LOCATION")
# On Windows, use registry last, not first
set(Python3_FIND_REGISTRY "LAST")
# On macOS, use framework last, not first
set(Python3_FIND_FRAMEWORK "LAST")

# Allow "make install" to not depend on all targets.
#
# Must be declared in the top-level CMakeLists.txt.
set(CMAKE_SKIP_INSTALL_ALL_DEPENDENCY true)

set(CMAKE_MACOSX_RPATH 1)
if(DEFINED ENV{MACOSX_DEPLOYMENT_TARGET})
  set(CMAKE_OSX_DEPLOYMENT_TARGET $ENV{MACOSX_DEPLOYMENT_TARGET})
else()
  set(CMAKE_OSX_DEPLOYMENT_TARGET 12.0)
endif()

# Generate a Clang compile_commands.json "compilation database" file for use
# with various development tools, such as Vim's YouCompleteMe plugin.
# See http://clang.llvm.org/docs/JSONCompilationDatabase.html
if("$ENV{CMAKE_EXPORT_COMPILE_COMMANDS}" STREQUAL "1")
  set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
endif()

if(UNIX)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
  # In the event that we are bundling the shared libraries (e.g. in a
  # manylinux1 wheel), we need to set the RPATH of the extensions to the
  # root of the pyarrow/ package so that libarrow is able to be
  # loaded properly
  if(APPLE)
    set(CMAKE_INSTALL_NAME_DIR "@rpath")
    set(CMAKE_INSTALL_RPATH "@loader_path/")
  else()
    set(CMAKE_INSTALL_RPATH "\$ORIGIN")
  endif()
endif()

find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND
   AND NOT CMAKE_C_COMPILER_LAUNCHER
   AND NOT CMAKE_CXX_COMPILER_LAUNCHER)
  message(STATUS "Using ccache: ${CCACHE_FOUND}")
  set(CMAKE_C_COMPILER_LAUNCHER ${CCACHE_FOUND})
  set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE_FOUND})
  # ARROW-3985: let ccache preserve C++ comments, because some of them may be
  # meaningful to the compiler
  set(ENV{CCACHE_COMMENTS} "1")
endif()

#
# Compiler flags
#

include(BuildUtils)

# Cython generated code emits way to many warnings at CHECKIN and EVERYTHING
set(BUILD_WARNING_LEVEL "PRODUCTION")

# This must be synchronized with the definition in
# cpp/cmake_modules/DefineOptions.cmake.
if(NOT DEFINED ARROW_SIMD_LEVEL)
  set(ARROW_SIMD_LEVEL
      "DEFAULT"
      CACHE STRING "Compile time SIMD optimization level")
endif()
if(NOT DEFINED ARROW_RUNTIME_SIMD_LEVEL)
  set(ARROW_RUNTIME_SIMD_LEVEL
      "MAX"
      CACHE STRING "Max runtime SIMD optimization level")
endif()
include(SetupCxxFlags)

if($ENV{PYODIDE})
  # These variables are needed for building PyArrow on Emscripten.
  # If they aren't set, CMake cross compiling fails for Python
  # modules (at least under Pyodide it does).
  set(Python3_INCLUDE_DIR $ENV{PYTHONINCLUDE})
  set(Python3_LIBRARY $ENV{CPYTHONLIB})
  set(Python3_EXECUTABLE)
  execute_process(COMMAND ${Python3_EXECUTABLE} -c
                          "import numpy; print(numpy.__version__)"
                  OUTPUT_VARIABLE PYODIDE_NUMPY_VERSION
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  string(REGEX MATCH "^([0-9]+)" PYODIDE_NUMPY_MAJOR_VERSION ${PYODIDE_NUMPY_VERSION})
  if(PYODIDE_NUMPY_MAJOR_VERSION GREATER_EQUAL 2)
    set(Python3_NumPy_INCLUDE_DIR $ENV{NUMPY_LIB}/_core/include)
  else()
    set(Python3_NumPy_INCLUDE_DIR $ENV{NUMPY_LIB}/core/include)
  endif()
  set(ENV{_PYTHON_SYSCONFIGDATA_NAME} $ENV{SYSCONFIG_NAME})
  # we set the c and cxx compiler manually to bypass pywasmcross
  # which is pyodide's way of messing with C++ build parameters.
  set(CMAKE_C_COMPILER emcc)
  set(CMAKE_CXX_COMPILER em++)
endif()

# Add common flags
set(CMAKE_CXX_FLAGS "${CXX_COMMON_FLAGS} ${CMAKE_CXX_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${PYARROW_CXXFLAGS}")

if(MSVC)
  # MSVC version of -Wno-return-type-c-linkage
  string(APPEND CMAKE_CXX_FLAGS " /wd4190")

  # Cython generates some bitshift expressions that MSVC does not like in
  # __Pyx_PyFloat_DivideObjC
  string(APPEND CMAKE_CXX_FLAGS " /wd4293")

  # Converting to/from C++ bool is pretty wonky in Cython. The C4800 warning
  # seem harmless, and probably not worth the effort of working around it
  string(APPEND CMAKE_CXX_FLAGS " /wd4800")

  # See https://github.com/cython/cython/issues/4445.
  #
  # Cython 3 emits "(void)__Pyx_PyObject_CallMethod0;" to suppress a
  # "unused function" warning but the code emits another "function
  # call missing argument list" warning.
  string(APPEND CMAKE_CXX_FLAGS " /wd4551")
else()
  # Enable perf and other tools to work properly
  string(APPEND CMAKE_CXX_FLAGS " -fno-omit-frame-pointer")

  # Suppress Cython warnings
  string(APPEND CMAKE_CXX_FLAGS " -Wno-unused-variable -Wno-maybe-uninitialized")

  if(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" OR CMAKE_CXX_COMPILER_ID STREQUAL
                                                    "Clang")
    # Cython warnings in clang
    string(APPEND CMAKE_CXX_FLAGS " -Wno-parentheses-equality")
    string(APPEND CMAKE_CXX_FLAGS " -Wno-constant-logical-operand")
    string(APPEND CMAKE_CXX_FLAGS " -Wno-missing-declarations")
    string(APPEND CMAKE_CXX_FLAGS " -Wno-sometimes-uninitialized")

    # We have public Cython APIs which return C++ types, which are in an extern
    # "C" blog (no symbol mangling) and clang doesn't like this
    string(APPEND CMAKE_CXX_FLAGS " -Wno-return-type-c-linkage")
  endif()
endif()

# For any C code, use the same flags.
set(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS}")

# Add C++-only flags, like -std=c++20
set(CMAKE_CXX_FLAGS "${CXX_ONLY_FLAGS} ${CMAKE_CXX_FLAGS}")

message(STATUS "CMAKE_C_FLAGS: ${CMAKE_C_FLAGS}")
message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")

if(MSVC)
  # MSVC makes its own output directories based on the build configuration
  set(BUILD_SUBDIR_NAME "")
else()
  # Set compile output directory
  string(TOLOWER ${CMAKE_BUILD_TYPE} BUILD_SUBDIR_NAME)
endif()

# If build in-source, create the latest symlink. If build out-of-source, which is
# preferred, simply output the binaries in the build folder
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_BINARY_DIR})
  set(BUILD_OUTPUT_ROOT_DIRECTORY
      "${CMAKE_CURRENT_BINARY_DIR}/build/${BUILD_SUBDIR_NAME}")
  # Link build/latest to the current build directory, to avoid developers
  # accidentally running the latest debug build when in fact they're building
  # release builds.
  file(MAKE_DIRECTORY ${BUILD_OUTPUT_ROOT_DIRECTORY})
  if(NOT APPLE)
    set(MORE_ARGS "-T")
  endif()
  execute_process(COMMAND ln ${MORE_ARGS} -sf ${BUILD_OUTPUT_ROOT_DIRECTORY}
                          ${CMAKE_CURRENT_BINARY_DIR}/build/latest)
else()
  set(BUILD_OUTPUT_ROOT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${BUILD_SUBDIR_NAME}")
endif()

message(STATUS "Generator: ${CMAKE_GENERATOR}")
message(STATUS "Build output directory: ${BUILD_OUTPUT_ROOT_DIRECTORY}")

# where to put generated archives (.a files)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${BUILD_OUTPUT_ROOT_DIRECTORY}")
set(ARCHIVE_OUTPUT_DIRECTORY "${BUILD_OUTPUT_ROOT_DIRECTORY}")

# where to put generated libraries (.so files)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${BUILD_OUTPUT_ROOT_DIRECTORY}")
set(LIBRARY_OUTPUT_DIRECTORY "${BUILD_OUTPUT_ROOT_DIRECTORY}")

# where to put generated binaries
set(EXECUTABLE_OUTPUT_PATH "${BUILD_OUTPUT_ROOT_DIRECTORY}")

# Python and Numpy libraries
find_package(Python3Alt REQUIRED)
message(STATUS "Found NumPy version: ${Python3_NumPy_VERSION}")
message(STATUS "NumPy include dir: ${NUMPY_INCLUDE_DIRS}")

include(UseCython)
message(STATUS "Found Cython version: ${CYTHON_VERSION}")

# Arrow C++ and set default PyArrow build options
include(GNUInstallDirs)
find_package(Arrow REQUIRED)

macro(define_option name description arrow_option)
  set("PYARROW_${name}"
      "AUTO"
      CACHE STRING ${description})

  if("${PYARROW_${name}}" STREQUAL "AUTO")
    # by default, first check if env variable exists, otherwise use Arrow C++ config
    set(env_variable "PYARROW_WITH_${name}")
    if(DEFINED ENV{${env_variable}})
      if($ENV{${env_variable}})
        set("PYARROW_BUILD_${name}" ON)
      else()
        set("PYARROW_BUILD_${name}" OFF)
      endif()
    else()
      if(${arrow_option})
        set("PYARROW_BUILD_${name}" ON)
      else()
        set("PYARROW_BUILD_${name}" OFF)
      endif()
    endif()
  else()
    if("${PYARROW_${name}}")
      set("PYARROW_BUILD_${name}" ON)
    else()
      set("PYARROW_BUILD_${name}" OFF)
    endif()
  endif()
endmacro()

define_option(ACERO "Build the PyArrow Acero integration" ARROW_ACERO)
define_option(CUDA "Build the PyArrow CUDA support" ARROW_CUDA)
define_option(DATASET "Build the PyArrow Dataset integration" ARROW_DATASET)
define_option(FLIGHT "Build the PyArrow Flight integration" ARROW_FLIGHT)

=== cpp/src/arrow/array/CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

add_arrow_test(concatenate_test)
add_arrow_test(data_test)
add_arrow_test(diff_test)

# Headers: top level
arrow_install_all_headers("arrow/array")

=== cpp/src/arrow/vendored/CMakeLists.txt ===
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

arrow_install_all_headers("arrow/vendored")

add_subdirectory(datetime)
add_subdirectory(double-conversion)
add_subdirectory(pcg)
add_subdirectory(portable-snippets)
add_subdirectory(safeint)
add_subdirectory(xxhash)

=== debian/changelog ===
apache-arrow (23.0.0-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * New upstream version.
  * d/copyright: No remnant LGPL-2.1 files, indeed.
    Removing reference as instructed by FTPadmins.
  * debian/*.install: replace hardcoded x86_64 (Closes: #1127564)
  * d/control: expressing unfortunate conflicts between library packages
    for puiparts
  * d/patches: Clean-up

  [ Rene Engelhard ]
  * Fix libarrow-python dependency tor test-pyarrow

 -- Steffen Moeller <moeller@debian.org>  Tue, 10 Feb 2026 15:10:52 +0000

=== debian/control ===
Source: apache-arrow
Section: devel
Priority: optional
Maintainer: Apache Arrow Developers <dev@arrow.apache.org>
Build-Depends:
  cmake,
  debhelper (>= 12),
  gi-docgen,
  git,
  gobject-introspection,
  libboost-filesystem-dev,
  libboost-system-dev,
  libbrotli-dev,
  libbz2-dev,
  libc-ares-dev,
  libcurl4-openssl-dev,
  libgirepository1.0-dev,
  libgoogle-glog-dev,
  libgrpc++-dev,
  libgtest-dev,
  liblz4-dev,
  libprotobuf-dev,
  libprotoc-dev,
  libre2-dev,
  libsnappy-dev,
  libssl-dev,
  libthrift-dev,
  libutf8proc-dev,
  libxxhash-dev,
  libzstd-dev,
  meson,
  ninja-build,
  nlohmann-json-dev | nlohmann-json3-dev,
  nvidia-cuda-toolkit [!arm64],
  pkg-config,
  protobuf-compiler,
  protobuf-compiler-grpc,
  tzdata,
  valac,
  zlib1g-dev
Build-Depends-Indep: libglib2.0-doc
Standards-Version: 3.9.8
Homepage: https://arrow.apache.org/

Package: libarrow2300
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends}
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ library files.

Package: arrow-tools
Section: utils
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides tools.

Package: libarrow-compute2300
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ library files for Compute support.

Package: libarrow-cuda2300
Section: libs
Architecture: i386 amd64
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ library files for CUDA support.

Package: libarrow-acero2300
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow-compute2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ library files for Acero module.

Package: libarrow-dataset2300
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow-acero2300 (= ${binary:Version}),
  libparquet2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ library files for Dataset module.

Package: libarrow-flight2300
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ library files for Flight RPC system.

Package: libarrow-flight-sql2300
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow-flight2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ library files for Flight SQL system.

Package: libarrow-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libabsl-dev,
  libarrow2300 (= ${binary:Version}),
  libbrotli-dev,
  libbz2-dev,
  libc-ares-dev,
  libcurl4-openssl-dev,
  liblz4-dev,
  libprotobuf-dev,
  libprotoc-dev,
  libre2-dev,
  libsnappy-dev,
  libssl-dev,
  libutf8proc-dev,
  libxxhash-dev,
  libzstd-dev,
  nlohmann-json-dev | nlohmann-json3-dev,
  protobuf-compiler-grpc,
  zlib1g-dev
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ header files.

Package: libarrow-compute-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-compute2300 (= ${binary:Version}),
  libarrow-dev (= ${binary:Version})
Replaces: libarrow-dev (<< 21.0.0-1)
Breaks: libarrow-dev (<< 21.0.0-1)
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ header files for compute module.

Package: libarrow-cuda-dev
Section: libdevel
Architecture: i386 amd64
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-cuda2300 (= ${binary:Version}),
  libarrow-dev (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ header files for CUDA support.

Package: libarrow-acero-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-acero2300 (= ${binary:Version}),
  libarrow-compute-dev (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ header files for Acero module.

Package: libarrow-dataset-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-acero-dev (= ${binary:Version}),
  libarrow-dataset2300 (= ${binary:Version}),
  libparquet-dev (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ header files for dataset module.

Package: libarrow-flight-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-dev (= ${binary:Version}),
  libarrow-flight2300 (= ${binary:Version}),
  libc-ares-dev,
  libgrpc++-dev
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ header files for Flight RPC system.

Package: libarrow-flight-sql-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-flight-dev (= ${binary:Version}),
  libarrow-flight-sql2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides C++ header files for Flight SQL system.

Package: libgandiva2300
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow2300 (= ${binary:Version})
Description: Gandiva is a toolset for compiling and evaluating expressions
 on Arrow Data.
 .
 This package provides C++ library files.

Package: libgandiva-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-dev (= ${binary:Version}),
  libgandiva2300 (= ${binary:Version})
Description: Gandiva is a toolset for compiling and evaluating expressions
 on Arrow Data.
 .
 This package provides C++ header files.

Package: libparquet2300
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow2300 (= ${binary:Version})
Description: Apache Parquet is a columnar storage format
 .
 This package provides C++ library files to process Apache Parquet format.

Package: parquet-tools
Section: utils
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libparquet2300 (= ${binary:Version})
Description: Apache Parquet is a columnar storage format
 .
 This package provides tools.

Package: libparquet-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libarrow-dev (= ${binary:Version}),
  libparquet2300 (= ${binary:Version}),
  libthrift-dev
Description: Apache Parquet is a columnar storage format
 .
 This package provides C++ header files.

Package: libarrow-glib2300
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow-acero2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based library files.

Package: gir1.2-arrow-23.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends:
  ${gir:Depends},
  ${misc:Depends},
  libarrow-glib2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GObject Introspection typelib files.

Package: libarrow-glib-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  gir1.2-arrow-23.0 (= ${binary:Version}),
  libarrow-acero-dev (= ${binary:Version}),
  libglib2.0-dev
Suggests: libarrow-glib-doc
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based header files.

Package: libarrow-glib-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
  ${misc:Depends}
Recommends: libglib2.0-doc
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides documentations.

Package: libarrow-cuda-glib2300
Section: libs
Architecture: i386 amd64
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow-cuda2300 (= ${binary:Version}),
  libarrow-glib2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based library files for CUDA support.

Package: gir1.2-arrow-cuda-23.0
Section: introspection
Architecture: i386 amd64
Multi-Arch: same
Depends:
  ${gir:Depends},
  ${misc:Depends},
  gir1.2-arrow-23.0 (= ${binary:Version}),
  libarrow-cuda-glib2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GObject Introspection typelib files for CUDA support.

Package: libarrow-cuda-glib-dev
Section: libdevel
Architecture: i386 amd64
Multi-Arch: same
Depends:
  ${misc:Depends},
  gir1.2-arrow-cuda-23.0 (= ${binary:Version}),
  libarrow-cuda-dev (= ${binary:Version}),
  libarrow-glib-dev (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based header files for CUDA support.

Package: libarrow-dataset-glib2300
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow-dataset2300 (= ${binary:Version}),
  libarrow-glib2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based library files for dataset module.

Package: gir1.2-arrow-dataset-23.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends:
  ${gir:Depends},
  ${misc:Depends},
  gir1.2-arrow-23.0 (= ${binary:Version}),
  libarrow-dataset-glib2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GObject Introspection typelib files for dataset module.

Package: libarrow-dataset-glib-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  gir1.2-arrow-dataset-23.0 (= ${binary:Version}),
  libarrow-dataset-dev (= ${binary:Version}),
  libarrow-glib-dev (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based header files for dataset module.

Package: libarrow-dataset-glib-doc
Section: doc
Architecture: any
Multi-Arch: foreign
Depends:
  ${misc:Depends}
Recommends: libarrow-glib-doc
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides documentations for dataset module.

Package: libarrow-flight-glib2300
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libarrow-glib2300 (= ${binary:Version}),
  libarrow-flight2300 (= ${binary:Version})
Description: Apache Arrow is a data processing library for analysis
 .
 This package provides GLib based library files for Apache Arrow Flight.

Package: gir1.2-arrow-flight-23.0

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile-gmake -*-
#
# import for DEB_TARGET_MULTIARCH
include /usr/share/dpkg/architecture.mk

# In anticipation of a future version of r-cran.mk
origRsubdir=r/
debRreposname=cran
cranNameOrig=arrow
cranName=arrow
#include /usr/share/dh-r/r-cran.mk

SOVERSION=2300


export DH_VERBOSE=1
export DH_OPTIONS

export DEB_BUILD_MAINT_OPTIONS=reproducible=-timeless hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_CPPFLAGS_MAINT_APPEND  = -D_FORTIFY_SOURCE=2
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,now

# For CMAKE output not to hide executed commands
export VERBOSE=1

BUILD_TYPE=release
PYBUILD_NAME=pyarrow
#PYBUILD_SYSTEM=cmake
PYBUILD_CONFIGURE_ARGS= \
 -DArrowAcero_DIR=$(pwd)/cpp_build/src/arrow/acero \
 -DParquet_DIR=$(pwd)/cpp_build/src/parquet/ \
 -DCMAKE_INSTALL_INCLUDEDIR=$(CURDIR)/debian/tmp/libarrow-dev/usr/include

#PYBUILD_CONFIGURE_ARGS=-DCMAKE_INSTALL_INCLUDEDIR=$(CURDIR)/debian/tmp/libarrow-dev/usr/include
# Skipping cython tests because it builds modules and needs to
# find an arrow library to link against, which doesnI't work
# using files installed into debian/tmp

export PYBUILD_TEST_ARGS=
#-m not distutils

%:
	dh $@ -with gir,python3

override_dh_auto_configure:
	#  Not explicitly specifying default setting
	#  -DARROW_S3=OFF
	#  Build failure:
	#  -DARROW_JEMALLOC_USE_SHARED=ON
	#  -DARROW_JEMALLOC=OFF			\
	#
	# Settings from https://arrow.apache.org/docs/developers/cpp/building.html
	dh_auto_configure			\
	  --sourcedirectory=cpp			\
	  --builddirectory=cpp_build		\
	  --buildsystem=cmake+ninja		\
	  --					\
	  -D_FORTIFY_SOURCE=2		   	\
	  -DCMAKE_VERBOSE_MAKEFILE=ON   	\
	  -DARROW_BUILD_BENCHMARKS=OFF		\
	  -DARROW_BUILD_EXAMPLES=OFF		\
	  -DARROW_BUILD_INTEGRATION=OFF		\
	  -DARROW_BUILD_TESTS=OFF       	\
	  -DARROW_BUILD_UTILITIES=ON    	\
	  -DARROW_USE_TSAN=OFF			\
	  -DARROW_BUILD_UTILITIES=OFF		\
	  -DARROW_ACERO=ON			\
	  -DARROW_ENABLE_TIMING_TESTS=OFF	\
	  -DARROW_FUZZING=OFF			\
	  -DARROW_CUDA=OFF              	\
	  -DARROW_CSV=ON			\
	  -DARROW_COMPUTE=ON			\
	  -DARROW_DATASET=ON			\
	  -DARROW_DEPENDENCY_SOURCE=SYSTEM	\
	  -DARROW_FILESYSTEM=ON			\
	  -DARROW_FLIGHT=ON			\
	  -DARROW_GANDIVA=ON			\
	  -DARROW_GANDIVA_JAVA=OFF		\
	  -DARROW_GCS=OFF               	\
	  -DARROW_HDFS=ON			\
	  -DARROW_IPC=OFF			\
	  -DARROW_JSON=ON			\
	  -DARROW_MIMALLOC=OFF	          	\
	  -DARROW_ORC=OFF			\
	  -DARROW_OPENSSL_USE_SHARED=ON		\
	  -DARROW_PARQUET=ON			\
	  -DARROW_PYTHON=ON			\
	  -DARROW_SNAPPY_USE_SHARED=ON		\
	  -DARROW_SUBSTRAIT=OFF			\
	  -DARROW_TENSORFLOW=OFF		\
	  -DARROW_USE_CCACHE=OFF		\
	  -DARROW_USE_ASAN=OFF			\
	  -DARROW_USE_SYSTEM=ON			\
	  -DARROW_USE_TSAN=OFF			\
	  -DARROW_USE_UBSAN=OFF			\
	  -DARROW_VERBOSE_THIRDPARTY_BUILD=ON	\
	  -DARROW_WITH_BROTLI=OFF		\
	  -DARROW_BROTLI_USE_SHARED=ON		\
	  -DARROW_WITH_BZ2=ON			\
	  -DARROW_WITH_LZ4=ON			\
	  -DARROW_WITH_SNAPPY=ON		\
	  -DARROW_WITH_RE2=ON			\
	  -DARROW_WITH_UTF8PROC=ON		\
	  -DARROW_WITH_ZLIB=ON			\
	  -DARROW_WITH_ZSTD=ON			\
	  -DBZip2_SOURCE=SYSTEM			\
	  -DArrowAcero_DIR=$(pwd)/cpp_build/src/arrow/acero -DParquet_DIR=$(pwd)/cpp_build/src/parquet/ \
	  -DCMAKE_INSTALL_PREFIX=/usr/      	\
	  -DCMAKE_BUILD_TYPE=$(BUILD_TYPE)

override_dh_auto_build:
	@echo " *** BUILD CPP *** "
	dh_auto_build				\
	  --sourcedirectory=cpp			\
	  --builddirectory=cpp_build		\
	  --buildsystem=cmake+ninja

	@echo " *** CONFIGURE GLIB *** "
	# Configure glib now that the primary library is built
	dh_auto_configure			\
	  --sourcedirectory=c_glib		\
	  --builddirectory=c_glib_build		\
	  --buildsystem=meson+ninja		\
	  --					\
	  -Darrow_cpp_build_type=$(BUILD_TYPE)	\
	  -Darrow_cpp_build_dir=../cpp_build	\
	  -Dgtk_doc=true

	@echo " *** BUILD GLIB *** "
	# Build glib version
	env					\
	  LD_LIBRARY_PATH=$(CURDIR)/cpp_build/$(BUILD_TYPE)	\
	  PKG_CONFIG_PATH=cpp_build/src/arrow/release/ \
	    dh_auto_build			\
	      --sourcedirectory=c_glib		\
	      --builddirectory=c_glib_build	\
	      --buildsystem=meson+ninja


override_dh_auto_install:

	@echo " *** INSTALL CPP *** "
	env					\
	  LD_LIBRARY_PATH=$(CURDIR)/cpp_build/$(BUILD_TYPE)	\
	  VERBOSE=1                             \
	dh_auto_install				\
	   --sourcedirectory=cpp		\
	   --builddirectory=cpp_build		\
	   --buildsystem=cmake+ninja

	@echo " *** INSTALL PYTHON *** "
	env	Arrow_DIR=$(CURDIR)/debian/tmp/usr \
		ArrowAcero_DIR=$(CURDIR)/debian/tmp/usr/lib/$(DEB_TARGET_MULTIARCH)/cmake/ArrowAcero \
		ArrowCompute_DIR=$(CURDIR)/debian/tmp/usr/lib/$(DEB_TARGET_MULTIARCH)/cmake/ArrowCompute \
		ArrowDataset_DIR=$(CURDIR)/debian/tmp/usr/lib/$(DEB_TARGET_MULTIARCH)/cmake/ArrowDataset \
		ArrowFlight_DIR=$(CURDIR)/debian/tmp/usr/lib/$(DEB_TARGET_MULTIARCH)/cmake/ArrowFlight \
		Gandiva_DIR=$(CURDIR)/debian/tmp/usr/lib/$(DEB_TARGET_MULTIARCH)/cmake/Gandiva \
		Parquet_DIR=$(CURDIR)/debian/tmp/usr/lib/$(DEB_TARGET_MULTIARCH)/cmake/Parquet \
		CMAKE_VERBOSE_MAKEFILE=ON	\
		PKG_CONFIG_PATH=cpp_build/src/arrow/release/ \
		VERBOSE=1			\
	dh_auto_install				\
	  --buildsystem=pybuild			\
	  --sourcedirectory=python		\
	  --builddirectory=python

	@echo " *** Clean up GLIB ***"
	# clean up glib version to reduce disk use
	env	PKG_CONFIG_PATH=cpp_build/src/arrow/release/ \
	dh_auto_clean				\
	  --sourcedirectory=c_glib		\
	  --builddirectory=c_glib_build		\
	  --buildsystem=meson+ninja

	@echo " *** Install C++ library with ninja ***"
	# cpp library is installed and cleaned in install step
	# to reduce build disk usage.
	# #install C++ version
	env	PKG_CONFIG_PATH=cpp_build/src/arrow/release/ \
	        VERBOSE=1                       \
	dh_auto_install				\
	   --sourcedirectory=cpp		\
	   --builddirectory=cpp_build		\
	   --buildsystem=cmake+ninja

	@echo " *** Building and installing R package ***"
	mkdir -p debian/tmp/usr/lib/R/site-library
	cd r && env \
		ARROW_R_DEV=true \
	        ARROW_USE_PKG_CONFIG=TRUE \
	        ARROW_JEMALLOC=OFF \
		ARROW_USE_CCACHE=OFF \
		LIBARROW_MINIMAL=true \
		NOT_CRAN=TRUE \
		PKG_CPPFLAGS_SITE="-I. -I$(CURDIR)/debian/tmp/usr/include/" \
	        VERBOSE=1 \
	R CMD INSTALL --configure-vars="INCLUDE_DIR='$(CURDIR)/debian/tmp/usr/include/'" --library=../debian/tmp/usr/lib/R/site-library/ .

	@echo " *** Clean cache directories - whereever they are ***"
	find debian/ -name __pycache__ -type d | xargs -r rm -r

	@echo " *** Clean cache directories - remnants in debian/tmp ***"
	rm -rf debian/tmp/usr/lib/python*/dist-packages/.pytest_cache/
	# I don't know why the python build is installing these.
	# I couldn't find a cmake option to turn it off.
	rm -rf debian/tmp/usr/lib/python*/dist-packages/src/
	rm -rf debian/tmp/usr/lib/python*/dist-packages/include/
	rm -rf debian/tmp/usr/lib/python*/dist-packages/tests/
	rm -rf debian/tmp/usr/lib/python*/dist-packages/pyarrow/src/

override_dh_install:
	# Eliminating python3.13 directory
	for i in $$(find debian/ -name "python3.*"); do echo "I: Found='$$i'"; a=$$(dirname $$i); if [ ! -d "$$(dirname "$$a")/python3" ]; then echo "I: renaming to '$$a/python3'"; mv "$$i" "$$a/python3"; fi ; done

	# Now performing the installation as instructed by the .install files
	dh_install
	# avoid conclflicts
	# with libarrow-dev
	rm -rf debian/pyarrow-dev/usr/share/arrow/gdb/gdb_arrow.py
	# with libarrow-python$(SOVERSION)
	rm -rf debian/python3-pyarrow/usr/lib/python3/dist-packages/pyarrow/libarrow_python.so.$(SOVERSION).0.0
	rm -rf debian/python3-pyarrow/usr/lib/python3/dist-packages/pyarrow/libarrow_python.so.$(SOVERSION)
	# with libarrow-python-flight$(SOVERSION)
	find debian/python3-pyarrow/usr/ -name "libarrow_python_flight.so*" -delete
	find debian/python3-pyarrow/usr/lib/ -name "_flight.*so" -delete
	find debian/python3-pyarrow/usr/lib/ -name "lib.cpython-*.so" -delete
	# Fix dependencies on Python for all packages
	dh_python3
	#dh_python3 --package=libarrow-python-flight$(SOVERSION) usr/lib/python3/dist-packages/pyarrow/libarrow_python_flight.so.$(SOVERSION)
